import os
import sys
from unidecode import unidecode
import zipfile
import zlib
import string
import re
# Этот скрипт архивирует все .docx и .fb2 файлы в рабочей директории, преобразуя их имена в транслит.
# При этом отсекается имя автора, пунтуация (кроме точек) удаляется, а пробелы заменяются подчёркиваниями.
path = os.getcwd()
os.chdir(path)
files = []
archives = []
# Читаем все файлы из рабочей директории
for file in os.listdir(path):
    if file.endswith('.fb2') or file.endswith('.docx'):
        files.append(file)
# Выходим, если книг, подлежащих архивации, в директории нет
if not files:
    sys.exit()
# Если они есть, то транслитерируем названия файлов и формируем имена архивов
for book in files:
    book_full = os.path.join(path, book)
    book_name, book_extension = os.path.splitext(book)
    if book_extension == ".docx":
        book_extension = ".zip"
    else:
        book_extension = ".fb2.zip"
    book_name = re.sub('^.*? -- ', '', book_name)
    book_name = re.sub(
        r'[\,\:\;\!\?«»„“”‘’\'\"「」『』‹›\<\>《》\(\)\[\]_\-–—\\¤\#\@\$\%\^\&\*\+\|\{\}]',
        ' ', book_name)
    book_name = re.sub(' +', '_', book_name)
    book_name = unidecode(book_name)
    book_name = re.sub(' +', '_', book_name)
    book_name = re.sub('_+', '_', book_name)
    book_name = re.sub('\'', '', book_name)
    archbook = book_name + book_extension
    archives.append(archbook)
# Архивируем все книги
compression = zipfile.ZIP_DEFLATED
for book, archive in zip(files, archives):
    zipfile.ZipFile(archive, "w", compression).write(book)
    os.remove(os.path.join(path, book))
