import os
import sys
import win32com.client as win32
# Этот скрипт конвертирует все файлы .txt, .rtf и .doc в рабочей директории
# в .docx, при конвертации документы обрабатываются макросами
# BookProp и DashesRus, а в файлах .txt и .rtf предварительно запускается
# макрос FormatText. Проверка наличия макросов в Normal.dotm не производится.
path = os.getcwd()
os.chdir(path)
files = []
for file in os.listdir(path):
    if file[-4:] in [".rtf", ".txt", ".doc"]:
        files.append(file)

if not files:
    sys.exit()

word = win32.gencache.EnsureDispatch("Word.Application")
word.Visible = False

for book in files:
    doc_full = os.path.join(path, book)
    doc_name, doc_extension = os.path.splitext(doc_full)
    docx_full = doc_name + ".docx"
    doc = word.Documents.Open(doc_full)
    if ".doc" not in doc_extension:
        word.Application.Run("Normal.NewMacros.FormatText")
    word.Application.Run("Normal.NewMacros.BookProps")
    word.Application.Run("Normal.NewMacros.DashesRus")
    doc.SaveAs(docx_full, FileFormat=16)
    doc.Close()
    os.remove(doc_full)

word.Quit()
