import os
import sys
import string
import re
# Этот скрипт добавляем указанный в конфиге код языка в название архива
# и делает первую букву названия прописной. Не забываем прописывать пути (строки 14-15)!
path = os.getcwd()
os.chdir(path)
cfg_files = []  # Список найденных конфигов
zipfiles_old = []  # Список архивов, подлежащих переименованию
lng_codes = []  # Языковые коды для переименования файлов
zipfiles_new = []  # Новые названия для архивов
lib_arc_path = "F:\\Alex\\Scripts"
lib_cfg_path = "F:\\Alex\\Scripts"


# Создание списка архивов, в именах которых отсутствует код языка при наличии его в конфиге.
def proclng(ntc, ltc):
    m = re.search(r'lng=\"([A-Z]{3})\"', ltc)
    n = re.search(r'lnk=\"(.+?)\"', ltc)
    if n:
        lng_code = m.group(1)
        if lng_code != "RUS":
            lnk = n.group(1)
            links = lnk.split("|")
            for k in range(len(links)):
                lng_code_ex = "." + lng_code + "."
                if lng_code_ex not in links[k]:
                    zipfiles_old.append(links[k])
                    zipfiles_new.append("")
                    lng_codes.append(lng_code)


# Функция обработки строк
def checkline(n, s):
    ntc = str(n + 1)
    if "book lvl" in s:  # Создаём список архивов, в названия которых нужно добавить код языка
        proclng(ntc, s)


# ===========================================================
# Отсель писать мы будем коды ---------------------------------------------------------------------
# Читаем все файлы .txt
for cfg_file in os.listdir(lib_cfg_path):
    if cfg_file.endswith('.txt'):
        cfg_files.append(cfg_file)

# Выходим, если файлов .txt в директории нет
if not cfg_files:
    sys.exit()

cfg_contents = []
# Если они есть, то читаем все
for cfg_file in cfg_files:
    f = open(os.path.join(lib_cfg_path, cfg_file), 'r')
    contents = f.read()
    cfg_contents.append(contents)
    f.close()

# Режем конфиг на строки
for i in range(len(cfg_contents)):
    zipfiles_old.clear()
    lng_codes.clear()
    zipfiles_new.clear()
    str1 = ".fb2.zip"
    str2 = ".zip"
    cfg_lines = cfg_contents[i].split('\n')
    # Перебираем полученные строки
    for j in range(len(cfg_lines)):
        alias, _ = os.path.splitext(cfg_files[i])
        checkline(j, cfg_lines[j])
    if zipfiles_old:  # Генерируем ноаые имена архивоа
        for l in range(len(zipfiles_old)):
            tmp = zipfiles_old[l][0].capitalize() + zipfiles_old[l][1:]
            if zipfiles_old[l].endswith(str1):
                zipfiles_new[l] = tmp.replace(str1,
                                              "") + "." + lng_codes[l] + str1
            elif zipfiles_old[l].endswith(str2):
                zipfiles_new[l] = tmp.replace(str2,
                                              "") + "." + lng_codes[l] + str2
    for l in range(len(zipfiles_old)):  # Заменяем имена в конфиге
        cfg_contents[i] = cfg_contents[i].replace(
            zipfiles_old[l], zipfiles_new[l])  # Перезаписываем конфиг
    f = open(os.path.join(lib_cfg_path, cfg_file), 'w')
    f.write(cfg_contents[i])
    f.close()
    for l in range(len(zipfiles_old)):  # Переименовываем архивы
        oname = os.path.join(lib_arc_path, alias, zipfiles_old[l])
        nname = os.path.join(lib_arc_path, alias, zipfiles_new[l])
        try:
            os.rename(oname, nname)
        except:
            print("Can't rename " + zipfiles_old[l] + " to " + zipfiles_new[l])