import os
import sys
import string
import re
from pathlib import Path
# Этот скрипт создает список отсутствующих пар .fb2 для файлов .docx в рабочей директории
# и записывает его в файл lost.txt

path = os.getcwd()
os.chdir(path)
files = []
archives = []
my_list = "lost.txt"
# Читаем все файлы .docx из рабочей директории
for file in os.listdir(path):
    if file.endswith('.docx'):
        files.append(file)

# Выходим, если файлов .docx в директории нет
if not files:
    sys.exit()

# Если они есть, то формируем список отсутствующих файлов .fb2
records = []
author = "Автор Авторов"
for book in files:
    book_full = os.path.join(path, book)
    book_name, book_extension = os.path.splitext(book)
    a = re.match('^(.*?) -- ', book_name)
    if a:
        author = a.group(1)
    fb2_book = book_name + ".fb2"
    fb2_to_check = Path(fb2_book)
    if not fb2_to_check.is_file():
        records.append(fb2_book)

# Выходим, если все файлы на месте
if not records:
    sys.exit()

# Убеждаемся, что файла lost.txt нет в рабочей директории, если он существует --
# добавляем единичку к имени и проверяем снова до достижения уникальности
my_file = Path(my_list)
while my_file.is_file():
    list_name, list_extension = os.path.splitext(my_list)
    list_name = list_name + "1"
    my_list = list_name + list_extension
    my_file = Path(my_list)

# Печатаем перечень отсутствующих файлов .fb2 в lost.txt
f = open(my_list, "w", encoding="utf-8")
f.write("Список отсутствующих файлов в формате .fb2 для автора " + author + "\n")
f.write("-----------------------------------------------------------------------------------------------" + "\n")
for rec in records:
    f.write(rec + "\n")
f.close()
